find_path(FFTW_INCLUDE_DIR fftw3.h)
if(FFTW_INCLUDE_DIR)
  find_library(FFTW_LIBRARY fftw3)
  find_library(FFTWF_LIBRARY fftw3f)
  if(FFTW_LIBRARY)
    set(OSSIA_FFT FFTW_DOUBLE CACHE INTERNAL "")
    set(OSSIA_FFT_FFTW 1 CACHE INTERNAL "")
    set(OSSIA_FFTW_DOUBLE_ONLY 1 CACHE INTERNAL "")

    add_library(fftw3 INTERFACE IMPORTED GLOBAL)
    add_library(fftw::fftw3 ALIAS fftw3)
    target_include_directories(fftw3 INTERFACE $<BUILD_INTERFACE:${FFTW_INCLUDE_DIR}>)
    target_link_libraries(fftw3 INTERFACE $<BUILD_INTERFACE:${FFTW_LIBRARY}>)
  elseif(FFTWF_LIBRARY)
    set(OSSIA_FFT FFTW_SINGLE CACHE INTERNAL "")
    set(OSSIA_FFT_FFTW 1 CACHE INTERNAL "")
    set(OSSIA_FFTW_SINGLE_ONLY 1 CACHE INTERNAL "")

    add_library(fftw3 INTERFACE IMPORTED GLOBAL)
    add_library(fftw::fftw3 ALIAS fftw3)
    target_include_directories(fftw3 INTERFACE $<BUILD_INTERFACE:${FFTW_INCLUDE_DIR}>)
    target_link_libraries(fftw3 INTERFACE $<BUILD_INTERFACE:${FFTWF_LIBRARY}>)
  endif()
endif()
